import random
class BatchIterator:
	def __init__(self,tensors,batch_size,shuffle=True):
		self.tensors = tensors # must be a tuple of tensor
		self.batch_size = batch_size
		# sanity check
		if not len(set([t.shape[0] for t in tensors])) == 1: print("ERROR : inconsistent input")
		self.indices = list(range(tensors[0].shape[0]))
		if shuffle: random.shuffle(self.indices)
	def __iter__(self): return self
	def __next__(self):
		batch_size= min(self.batch_size,len(self.indices))
		if batch_size==0: raise StopIteration
		indices = [self.indices.pop(0) for s in range(batch_size)]
		return [torch.stack([t[i] for i in indices],0) for t in self.tensors]

### usage example
# xs = torch.randn(10,1,28,28)
# ys = torch.randn(10,10)
# for i,(x,y) in enumerate(BatchIterator((xs,ys),3)):
# 	print(x.shape,y.shape)

